#!/usr/bin/env python3

from cmk.gui.i18n import _

from cmk.gui.valuespec import (
    Dictionary,
    Percentage,
)

from cmk.gui.plugins.wato import (
    CheckParameterRulespecWithoutItem,
    rulespec_registry,
    RulespecGroupCheckParametersApplications,
)

def _parameter_valuespec_proxmox_allocation_ratio():
    return Dictionary(
        elements=[
            ("cpu", Tuple(
                title=_("Levels on CPU resource allocation %"),
                elements=[
                    Percentage(title=_("Warning at"),
                            label=_("% of CPU allocated"),
                            default_value=100.0,
                            maxvalue=None),
                    Percentage(title=_("Critical at"),
                            label=_("% of CPU allocated"),
                            default_value=105.0,
                            maxvalue=None),
                ],
            ),
            ),
            ("memory", Tuple(
                title=("Levels on memory resource allocation %"),
                elements=[
                    Percentage(title=("Warning at"),
                            label=_("% of Memory allocated"),
                            default_value="100.0",
                            maxvalue=None),
                    Percentage(title=("Critical at"),
                            label=_("% of Memory allocated"),
                            default_value="105.0",
                            maxvalue=None),


                ],
            ),
            ),
        ],
    )

rulespec_registry.register(
    CheckParameterRulespecWithoutItem(
        check_group_name="pve_allocation_ratio",
        group=RulespecGroupCheckParametersApplications,
        match_type="dict",
        parameter_valuespec=_parameter_valuespec_proxmox_allocation_ratio,
        title=lambda: _("Proxmox VE Resource Allocation Ratios"),
    ))
